import {
  select, max
}
from 'd3';

export const barChart = () => {

  // All options that should be accessible to caller
  let data = [];
  let width = 900;
  let height = 200;
  let barPadding = 1;
  let fillColor = 'red';
  let barSpacing;
  let barHeight;
  let maxValue;
  let widthScale;
  let svg;

  let updateData = () => {  };
  let updateWidth = () => {  };
  let updateFillColor = () => {  };
  
  
  const calculate = () => {
    barSpacing = height / data.length;
    barHeight = barSpacing - barPadding;
    maxValue = max(data);
    widthScale = width / maxValue;
  }
  
  const update = () => {
    calculate();
    const kUpdate = svg.selectAll('rect').data(data);
    const kEnter = kUpdate.enter().append('rect');
    kUpdate.merge(kEnter)
      .transition().duration(900)
        .attr('y', (d, i) => i * barSpacing)
        .attr('height', barHeight)
        .attr('x', 0)
        .attr('width', d => d * widthScale)
        .style('fill', fillColor);
    kUpdate.exit().remove();
  };

  let chart = selection => {
    svg = selection
      .append('svg')
        .attr('height', height)
        .attr('width', width);
    update();

    updateWidth = () => {
      update();
    };

    updateData = () => {
      update();
    };
    
    updateFillColor = () => {
      selection.selectAll("rect")
        .transition()
        .style("fill", fillColor);
    };
    
    
  }

  chart.data = function(value) {
    if (!arguments.length) return data;
    data = value;
    updateData();
    return chart;
  };

  chart.width = function(value) {
    if (!arguments.length) return width;
    width = value;
    updateWidth();
    return chart;
  };

  chart.height = function(value) {
    if (!arguments.length) return height;
    height = value;
    return chart;
  };

  chart.barPadding = function(value) {
    if (!arguments.length) return barPadding;
    barPadding = value;
    return chart;
  };

  chart.fillColor = function(value) {
    if (!arguments.length) return fillColor;
    fillColor = value;
    updateFillColor();
    return chart;
  };

  return chart;
}